<?php

class WP_AppStore_Widget extends WP_Widget {
	function WP_AppStore_Widget() {
		//Konstruktor
		$widget_ops = array('classname' => 'widget_AppStore_Widget', 'description' => 'Zeigt die Top 10 der AppStore Charts' );
		$this->WP_Widget('AppStore_Widget', 'Appstore', $widget_ops);
		
		if ( is_active_widget(false, false, $this->id_base) )
             add_action( 'wp_head', array(&$this, 'recent_widget_style') );
	}
	
	function recent_widget_style() { 
			//<style type="text/css">css/widget.css</style>
			echo '<link href="'.WP_PLUGIN_URL."/".PLUGIN_BASE_DIRECTORY.'/css/widget.css" rel="stylesheet" type="text/css" />';			
	}
 
	function widget($args, $instance) {
		extract($args, EXTR_SKIP);
		$wtitle = apply_filters('widget_title', empty( $instance['title'] ) ? __( 'Top 10 Apps' ) : $instance['title']);
		//$freePaid = apply_filters('widget_title', empty( $instance['freePaid'] ) ? __( 'free' ) : $instance['freePaid']);
		$topCount = apply_filters('widget_title', empty( $instance['topCount'] ) ? __( '10' ) : $instance['topCount']);
		$freePaid = attribute_escape($instance['freePaid']) ;
        $Country = attribute_escape($instance['Country']) ;
		
		echo $before_widget .$before_title . $wtitle . $after_title;	
		$language = get_option("AppStore_language");
		$doc = new DOMDocument();
		if ($freePaid == "free") {
			$feed = RSS_TOPFREE.$Country."/lang=".$language."/limit=".$topCount."/xml";
		} else {
			$feed = RSS_TOPPAID.$Country."/lang=".$language."/limit=".$topCount."/xml";
		}

		$feedUpdateIntervall = $instance['feedUpdateIntervall'];
		
		if ($feedUpdateIntervall == "") {
			$feedUpdateIntervall = 60*60*60;
		} else {
			$feedUpdateIntervall = $feedUpdateIntervall*60*60;
		}
		
		echo  $instance['feedUpdateTime'].'<br />';  
		
		if ((time() - $feedUpdateIntervall) < $instance['feedUpdateTime']) {
			//echo "Cache<br />";
			$doc = $instance['feedCache'];
		} else {
			//echo'Load<br />'; 
			$doc->load($feed);
			$instance['feedCache'] =  $doc;
			$instance['feedUpdateTime'] = time();
		}
		//echo  $instance['feedUpdateTime'].'<br />';  
			
		$appList = '<ul class="pageitem">'; 
		
		foreach ($doc->getElementsByTagName('entry') as $node) {
			$title = htmlspecialchars($node->getElementsByTagName('name')->item(0)->nodeValue); 
			$id	= ExtractID(utf8_encode($node->getElementsByTagName('id')->item(0)->nodeValue));
			$price	= htmlspecialchars($node->getElementsByTagName('price')->item(0)->nodeValue);
			$sellerName	= htmlspecialchars(utf8_encode($node->getElementsByTagName('artist')->item(0)->nodeValue));
			$image = utf8_encode($node->getElementsByTagName('image')->item(0)->nodeValue);
			$afflink = WP_PLUGIN_URL."/".PLUGIN_BASE_DIRECTORY."/AppStore.php?appid=".$id;
					
			$appList .=	'<li class="store">
					<a class="noeffect" href="'.$afflink.'" rel="nofollow">
					<img class="image" style=" width: 45px; height: 45px; -webkit-border-radius: 8px; -moz-border-radius: 8px;" src=\''.$image.'\'></img>
					<span class="comment">'.$sellerName.'</span><span class="name">'.$title.'</span>
					<span class="comment">'.$price.'</span>					
					</a>
				</li>';
			
			}
		$appList .= "</ul>";
		echo $appList; 
				
		echo $after_widget;
	}
 
	function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['freePaid'] =  strip_tags($new_instance['freePaid']);
		$instance['topCount'] =  strip_tags($new_instance['topCount']);
		$instance['Country'] =  strip_tags($new_instance['Country']);
		$instance['feedUpdateIntervall'] =  strip_tags($new_instance['feedUpdateIntervall']);
		$instance['feedCache'] = '';
		$instance['feedUpdateTime'] = '';
		
		return $instance;
	}
 
	function form($instance) {
		$instance = wp_parse_args( (array) $instance, array( 'title' => '', 'freePaid' => '', 'topCount' => '', 'Country' => '', 'feedCache' => '', 'feedUpdateTime' => '', 'feedUpdateIntervall' => '' ) );
		$title = attribute_escape($instance['title']);
		$freePaid = attribute_escape($instance['freePaid']) ;
        $topCount = attribute_escape($instance['topCount']) ;
		$Country = attribute_escape($instance['Country']) ;
		$feedCache = attribute_escape($instance['feedCache']) ;
		$feedUpdateTime = attribute_escape($instance['feedUpdateTime']) ;
		$feedUpdateIntervall= attribute_escape($instance['feedUpdateIntervall']) ;
		
		if ($freePaid == "free" ) {
			$checked = "checked" ;
			} else {
			$checked = "" ;
			}
		
		if ($topCount == "" ) {
			$topCount = "10"  ;
			}
			
		if ($title == "" ) {
			$title = "Top Apps"  ;
			}

		if ($Country == "" ) {
			$Country = "143445"  ;
			}
			
		if ($feedUpdateIntervall == "" ) {
			$feedUpdateIntervall = "60"  ;
			}			
			
		$Countries = array(
							143441 => "United States",
							143442 => "France", 
							143443 => "Germany", 
							143444 => "United Kingdom", 
							143445 => "Austria", 
							143446 => "Belgium", 
							143447 => "Finland", 
							143448 => "Greece", 
							143449 => "Ireland", 
							143450 => "Italy", 
							143451 => "Luxembourg", 
							143452 => "Netherlands", 
							143453 => "Portugal", 
							143454 => "Spain", 
							143455 => "Canada", 
							143456 => "Sweden", 
							143457 => "Norway", 
							143458 => "Denmark", 
							143459 => "Switzerland", 
							143460 => "Australia", 
							143461 => "New Zealand",
							143462 => "Japan"
							);
		asort($Countries);
		
			
		?>
		<p><label for="<?php echo $this->get_field_id('title'); ?>">Titel: <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo attribute_escape($title); ?>" /></label></p>
		<p><label for="<?php echo $this->get_field_id('topCount'); ?>">Top (Anzahl): <input class="widefat" id="<?php echo $this->get_field_id('topCount'); ?>" name="<?php echo $this->get_field_name('topCount'); ?>" type="text" value="<?php echo attribute_escape($topCount); ?>" /></label></p>
		<p><label for="<?php echo $this->get_field_id('Country'); ?>">Land: <select class="widefat" name="<?php echo $this->get_field_name('Country'); ?>" id="<?php echo $this->get_field_id('Country'); ?>"><br />"; 
										<?php
										foreach($Countries as $Key => $Countryname)
										{
											echo '<option value="'.$Key.'"';
											if(attribute_escape($Country) == $Key) {
												echo ' selected="selected"';
											}
											echo ">".$Countryname."</option>";
										}
										
										?>
										</select>								
									
		<p><label for="<?php echo $this->get_field_id('freePaid'); ?>">Gratis Apps: <input id="<?php echo $this->get_field_id('freePaid'); ?>" name="<?php echo $this->get_field_name('freePaid'); ?>" type="checkbox" value="free" <?php echo $checked; ?> /></label></p> 
		<p><label for="<?php echo $this->get_field_id('feedUpdateIntervall'); ?>">Updateintervall in Sec <input class="widefat" id="<?php echo $this->get_field_id('feedUpdateIntervall'); ?>" name="<?php echo $this->get_field_name('feedUpdateIntervall'); ?>" type="text" value="<?php echo attribute_escape($feedUpdateIntervall); ?>" /></label></p>
		<?php
		
	}
	
	function widget_control()
	{
		echo "Konfiguration bei den Settings";
	}
}

function wp_AppStoreWidget_init() {
	        if ( !is_blog_installed() )
	                return;
			register_widget('WP_AppStore_Widget');
}
add_action('init', 'wp_AppStoreWidget_init', 1);
